//
//  ViewController+Merchant.m
//  MVisaSDKAppObjC
//
//  Created by Jain, Abhinav on 5/2/17.
//  Copyright © 2017 Parihar, Sagar. All rights reserved.
//

#import "ViewController+Merchant.h"
#import "MVisaMerchantSDK/MVisaMerchantSDK.h"

@interface ViewController (Merchant) <MVisaRequestPaymentDelegate, MVisaRefundPaymentDelegate>

- (void)initiateRequestPaymentFlow;
- (void)initiateRefundFlow;

@end



@implementation ViewController (Merchant)


- (void)initiateRequestPaymentFlow {
    MVisaConfig *config = [[MVisaConfig alloc]init];
    [MVisaMerchantSDK setupOneTimeConfiguration:config];
    
    MVisaPaymentRequest *request = [[MVisaPaymentRequest alloc] initWithPayloadFormatIndicator:@"01" pointOfInitiation:@"01" mVisaMerchantID:@"4111111111111111" merchantName:@"Corner Store" merchantCategoryCode:@"1234" cityName:@"Delhi" countryCode:@"IN" currencyCode:@"356" tipIndicator:@"" tipAmount:@"" tipPercentage:@"" postalCode:@"" mastercardPan1:@"" mastercardPan2:@"" npciid1:@"" npciid2:@""];
    
    [MVisaMerchantSDK launchRequestPaymentFlowWithRequest: request delegate: self];
    
}

- (void)requestPaymentFlowDidFinish:(BOOL)successful withResponse:(MVisaRequestPaymentResponse * _Nullable)requestPaymentResponse withError:(MVisaError * _Nullable)error {
    // close the MVisaSDK UI and return to host app
    [MVisaMerchantSDK endMVisaFlow:nil];
}


// code to launch refund payment flow
- (void)initiateRefundFlow {
    // create and set one time config
    MVisaConfig *config = [[MVisaConfig alloc]init];
    [MVisaMerchantSDK setupOneTimeConfiguration:config];
    
    // create refund payment request
    MVisaRefundPaymentRequest *request = [[MVisaRefundPaymentRequest alloc] initWithLast4: @"1234" cardHolderName: @"James Gawn" currencyCode: @"840" refundAmount: @"123456789.99"];
    
    // launch the MVisaMerchant refund payment flow
    // overload function can also be used with a completion block
    [MVisaMerchantSDK launchRefundPaymnetFlowWithRequest: request delegate: self];
    
}

// delegate method called on completion of refund payment flow
- (void)refundPaymentFlowDidFinish:(BOOL)successful withResponse:(MVisaRefundPaymentResponse * _Nullable)refundPaymentResponse withError:(MVisaError * _Nullable)error {
    
    if(successful) {
        NSLog(@"refundAmount : %@",refundPaymentResponse.refundAmount);
    } else {
        NSLog(@"MVisaMerchant refund payment flow was unsuccessful");
    }
    // close the MVisaSDK UI and return to host app
    [MVisaMerchantSDK endMVisaFlow:nil];
}

@end
